/*
 * DCTerminal.h
 *
 *		   IDE: Eclipse Kepler
 *  Created on: 04. Октября. 2013 г.
 *      Author: DruidCat
 */

#include "DCTerminal.h"

#include <QApplication>
#include <QWidget>
#include <QRadioButton>
#include <QPushButton>
#include <QGroupBox>
#include <QString>
#include <QBoxLayout>
#include <QGridLayout>
#include <QChar>
#include <QSplitter>
#include <QTextEdit>
#include <QDebug>
#include <QSerialPort>
#include <QLineEdit>
#include <QLabel>
#include <QPalette>

DCTerminal::DCTerminal(QWidget* pwgt) : QWidget(pwgt)//Конструктор класса Терминал
{
	pserialPort							= new QSerialPort;

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////П А Р А М Е Т Р Ы   П О   У М О Л Ч А Н И Ю///////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	m_strPortName			= "com1";
	m_strBaudRate			= "115200";
	m_strDataBits			= "8";
	m_strParity				= "none";
	m_strStopBits			= "1";
	m_strFlowControl		= "NoFlowControl";
	m_uiComSettingCounter	= 0;
	m_blConnectButtonClicked= false;

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////М А С С И В Ы   Д А Н Н Ы Х///////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QString strComPort[5][2] = {{ "com1", "com6" },
								{ "com2", "com7" },
								{ "com3", "com8" },
								{ "com4", "com9" },
								{ "com5", "com10" }
	};//Массив номеров сом портов
	QString strComBaud [4][2]={	{	"1200",	"19200",	},
								{	"2400",	"38400",	},
								{	"4800",	"57600",	},
								{	"9600",	"115200"	}
	};//Массив скоростей сом порта
	QString strComData [4] = 	{	"5", "6", "7", "8"	};//массив чисел передоваемых бит
	QString strComParity [5] =	{	"none", "even", "odd", "space", "mark"	};
	QString strComStop [3] =	{	"1", "1.5", "2"	};//массив колличества стоповых бит
	QString strComFlowControl[3]={	"NoFlowControl", "HardwareControl", "SoftwareControl"	};

	QVBoxLayout*	pvbxLayout			= new QVBoxLayout;//Главная вертикальная компоновка
	QHBoxLayout*	phbxLayout			= new QHBoxLayout;//Горизонтальная компоновка настроек сом порта
	QVBoxLayout*	pvbxLayoutButton	= new QVBoxLayout;//Вертикальная компоновка кнопок управление сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////К Н О П К А   П О Д К Л Ю Ч Е Н И Е///////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	pcmdConnect							= new QPushButton("Подключение");//Кнопка отвечающая за подключение к сом порту программы терминал
	pcmdConnect->setCheckable(true);//Делаем кнопку в режиме Выключателя.
	pcmdConnect->setChecked(false);//Делаем кнопку в режим ВЫКЛ.
	connect (	pcmdConnect,
			 	 SIGNAL(clicked()),
			 	 this,
			 	 SLOT(slotConnectButtonClicked()));//при нажатии кнопки Подключение, открывается и конфигурируется СОМ порт
	connect (	pserialPort,
				SIGNAL(readyRead()),
				this,
				SLOT(slotReadComData()));//Когда СОМ порт готов принимать данные, активизируется прием данных по СОМ порту

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////К Н О П К А   О Ч И С Т И Т Ь////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QPushButton*	pcmdReadClear		= new QPushButton("Очистить");
	connect(	pcmdReadClear,
				SIGNAL(clicked()),
				this,
				SLOT(slotReadClear()));//При нажатии на кнопку Очистить, очищаемтся окно приема данных по СОМ порту

	/////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////К Н О П К А   И Н Ф О Р М А Ц И Я//////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	plblShowInfo						= new QLabel(	"DCTerminal:\tver 1.0\n"
														"DruidCat\t\t2013 год\n"
														"email:\t\tdruiacat@yandex.ru\n"
														"Высота\t\t239\n");//Конструктор Окна Информации
	QPalette		ppltShowInfo;//Создаем объект палитры
	ppltShowInfo.setColor(plblShowInfo->backgroundRole(), Qt::gray);//Делаем задний фон Окна Информации серым
	plblShowInfo->setPalette(ppltShowInfo);//Добавляем палитру в Лэйбл
	plblShowInfo->setWindowTitle("Информация");//Задаем имя окошка
	plblShowInfo->setFrameStyle(QFrame::Box | QFrame::Raised);//Задаем стиль рамочки окна Информации
	plblShowInfo->setFixedHeight(100);//Фиксированная высота 100 пикселей
	plblShowInfo->setFixedWidth(200);//Фиксированная длинна 200 пикселей

	QPushButton*	pcmdShowInfo		= new QPushButton("Информация");//Кнопка выводящаа информацию о программе
	connect (	pcmdShowInfo,
				SIGNAL(clicked()),
				plblShowInfo,
				SLOT(show()));//При нажатии на кнопку "Информация" появляется окно с информацией о программе

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////К Н О П К А   В Ы Х О Д///////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QPushButton*	pcmdQuit			= new QPushButton("Выход");//Кнопка отвечающая за выход программы
	connect (	pcmdQuit,
			 	SIGNAL(clicked()),
			 	this,
			 	SLOT(slotMainQuit()));//Наделяем действием Закрытия программы  кнопку Выход

	pvbxLayoutButton->addWidget(pcmdConnect);//добовляем кнопку в компоновку
	pvbxLayoutButton->addWidget(pcmdReadClear);//добавляем кнопку очистки экрана
	pvbxLayoutButton->addWidget(pcmdShowInfo);//добавляем кнопку Информация
	pvbxLayoutButton->addWidget(pcmdQuit);//добовляем кнопку в компоновку
	phbxLayout->addLayout(pvbxLayoutButton);//Добовляем вертикальную компоновку кнопок в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////Г Р У П П А   С О М   П О Р Т////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	pgbxComPort							= new QGroupBox ("COM порт");//Группировочный виджет
	QGridLayout*	pgrdComPort			= new QGridLayout;//Матричная компоновка названий сом порта
	for (unsigned int x = 0; x < 2; ++x)//Массив по Х
		for (unsigned int y = 0; y < 5; ++y)//Массив по У
		{
			pgrdComPort->addWidget(createRadioButton(strComPort[y][x]), y, x);//Добавляем в матричную компоновку создаваемые радио кнопки наделенные именами из масива имен ком портов
		}
	pgbxComPort->setLayout(pgrdComPort);//Добовляем матричную компоновку с радио кнопками в группировочный виджет

	phbxLayout->addWidget(pgbxComPort);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////Г Р У П П А  B A U D   R A T E///////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QGroupBox*		pgbxComBaud			= new QGroupBox ("Baud Rate");//Группировочный виджет
	QGridLayout*	pgrdComBaud			= new QGridLayout;//Матричная компоновка скоростей сом порта
	for (unsigned int x = 0; x < 2; ++x)//Массив по Х
		for (unsigned int y = 0; y < 4; ++y)//Массив по У
			pgrdComBaud->addWidget(createRadioButton(strComBaud[y][x]), y, x);//Добавляем в матричную компоновку создаваемые радио кнопки наделенные именами из масива скоростей ком портов
	pgbxComBaud->setLayout(pgrdComBaud);//Добовляем матричную компоновку с радио кнопками в группировочный виджет
	phbxLayout->addWidget(pgbxComBaud);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////Г Р У П П А  D A T A   B I T S///////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QGroupBox*		pgbxComData			= new QGroupBox ("Data Bits");//Группировочный виджет
	QVBoxLayout*	pvbxComData			= new QVBoxLayout;//Вертикальная компоновка
	for(unsigned int y = 0; y < 4; ++y)
		pvbxComData->addWidget(createRadioButton(strComData[y]));
	pgbxComData->setLayout(pvbxComData);//Добовляем матричную компоновку с радио кнопками в группировочный виджет
	phbxLayout->addWidget(pgbxComData);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////Г Р У П П А  P A R I T Y//////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QGroupBox*		pgbxComParity		= new QGroupBox ("Parity");//Группировочный виджет
	QVBoxLayout*	pvbxComParity		= new QVBoxLayout;//Вертикальная компоновка
	for (unsigned int y = 0; y < 5; ++y)
		pvbxComParity->addWidget(createRadioButton(strComParity[y]));
	pgbxComParity->setLayout(pvbxComParity);//Добовляем матричную компоновку с радио кнопками в группировочный виджет
	phbxLayout->addWidget(pgbxComParity);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////Г Р У П П А  S T O P   B I T S///////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QGroupBox*		pgbxComStop			= new QGroupBox ("Stop Bits");//Группировочный виджет
	QVBoxLayout*	pvbxComStop			= new QVBoxLayout;//Вертикальная компоновка
	for (unsigned int y = 0; y < 3; ++y)
		pvbxComStop->addWidget(createRadioButton(strComStop[y]));
	pgbxComStop->setLayout(pvbxComStop);//Добовляем матричную компоновку с радио кнопками в группировочный виджет
	phbxLayout->addWidget(pgbxComStop);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта

	/////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////Г Р У П П А  F L O W C O N T R O L/////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QGroupBox*		pgbxComFlowControl	= new QGroupBox ("FlowControl");//Группировочный виджет
	QVBoxLayout*	pvbxComFlowControl	= new QVBoxLayout;//Вертикальная компоновка
	for (unsigned int y = 0; y < 3; ++y)
		pvbxComFlowControl->addWidget(createRadioButton(strComFlowControl[y]));
	pgbxComFlowControl->setLayout(pvbxComFlowControl);//Добовляем матричную компоновку с радио кнопками в группировочный виджет
	phbxLayout->addWidget(pgbxComFlowControl);//Добовляем группировочный виджет в горизонтальную компоновку настроек сом порта
	pvbxLayout->addLayout(phbxLayout);//Добавляем горизонтальный виджет настроек сом порта в главный вертикальный виджет

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////К О М П О Н О В К А   П Р И Ё М А/////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QVBoxLayout*		pvbxLayoutComIO = new QVBoxLayout;//Вертикальная компоновка приема и передачи данных по сом порту
	ptxtReadCom = new QTextEdit;//Указатель на текстовую область приема данных по сом порту
	pvbxLayoutComIO->addWidget(ptxtReadCom);//Добавляем текстовую область в компоновку ввода/вывода

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////К О М П О Н О В К А   О Т П Р А В И Т Ь//////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	QHBoxLayout*		phbxLayoutSendCom = new QHBoxLayout;//Горизонтальная компоновка для поля и кнопки ввода данных
	QPushButton*		pcmdWriteCom = new QPushButton ("Оправить");//Кнопка отправить данные по сом порту
	ptxtWriteCom = new QLineEdit;//Текстоваю область ввода данных, для отправки по сом порту
	ptxtWriteCom->setMaxLength(512);//Устанавливаем максимальное вводимое число символов 512

	connect (	ptxtWriteCom,
				SIGNAL(textChanged(const QString&)),
				this,
				SLOT(slotWriteText(const QString&)));//Если изменяется вводимый текст, то он присваевается к переменной

	connect (	pcmdWriteCom,
				SIGNAL(clicked()),
				this,
				SLOT(slotWriteComData()));//Если нажимается кнопка отправить, отправляем вводимый текст по СОМ порту

	connect (	ptxtWriteCom,
				SIGNAL(returnPressed()),
				this,
				SLOT(slotWriteComData()));//Если нажат Enter, отправляем вводимый текст по СОМ порту

	phbxLayoutSendCom->addWidget(ptxtWriteCom);//Компонуем область ввода данных
	phbxLayoutSendCom->addWidget(pcmdWriteCom);//компонуем кнопку "отправить"

	pvbxLayoutComIO->addLayout(phbxLayoutSendCom);//Компонуем компоновку ввода/вывода в главную компоновку

	pvbxLayout->addLayout(pvbxLayoutComIO);//Добавляем виджет разделенного экрана в главную вертикальную компоновку

	if (!(m_uiComSettingCounter == 21))//Проверка правильности задания первоначальных параметров сом порта
		ptxtReadCom->setText("Ошибка первоначальных параметров СОМ порта.");

	setLayout(pvbxLayout);//Инициализируем главную вертикальную компоновку
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////C R E A T E   R A D I O   B U T T O N////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
QRadioButton* DCTerminal::createRadioButton(const QString& rstrNameButton)//Метод принимающий название радио кнопки в виде ссылки и возвращающий указатель на созданную радио кнопку
{
	QRadioButton*		pradSerialPort	= new QRadioButton(rstrNameButton);//Создаем указатель на созданную радио кнопку
/*TODO Не доработанная функция, нужно сделать ReScan портов
	if ((rstrNameButton == "com1") || (rstrNameButton == "com2") || (rstrNameButton == "com3") || (rstrNameButton == "com4") || (rstrNameButton == "com5") || (rstrNameButton == "com6") || (rstrNameButton == "com7") || (rstrNameButton == "com8") || (rstrNameButton == "com9") || (rstrNameButton == "com10"))
	{
		QString strportName (rstrNameButton);//Промежуточная строчка имени порта
		strportName = strportName.toUpper();//Делаем все символы верхнего регистра.
		QSerialPortInfo*	pserialPortInfo	= new QSerialPortInfo(strportName);//Указатель на класс QSerialPortInfo с иннициализацией СОМ порта в конструкторе

		if(!(pserialPortInfo->isValid()))//если СОМ порт не подключет, то...
			pradSerialPort->setEnabled(false);//Деактивируем радио кнопку данного СОМ порта
	}
*/
	if (rstrNameButton == m_strPortName)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 1;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	if (rstrNameButton == m_strBaudRate)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 2;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	if (rstrNameButton == m_strDataBits)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 3;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	if (rstrNameButton == m_strParity)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 4;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	if (rstrNameButton == m_strStopBits)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 5;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	if (rstrNameButton == m_strFlowControl)//Сравниваем заданные параметры порта с полученными
	{
		pradSerialPort->setChecked(true);//Радио кнопку делаем активной
		m_uiComSettingCounter += 6;//Для контрольной суммы корректных первоначальных настроек СОМ порта
	}

	connect (	pradSerialPort,
			 	SIGNAL(clicked()),
			 	this,
			 	SLOT(slotRadioButtonClicked()));//Связываем нажатие радио кнопки с действием изменения настроек СОМ порта

	return pradSerialPort;//Возвращаем указатель на созданную радио кнопку
}

/////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////S L O T   R A D I O   B U T T O N   C L I C K E D//////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotRadioButtonClicked()//Слот обрабатывающий нажатие радио кнопок
{
	QString str = ((QRadioButton*)sender())->text();//Принимаем текс названия нажатой радио кнопки

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////В Ы Б О Р   С О М   П О Р Т А////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ((str == "com1") || (str == "com2") || (str == "com3") || (str == "com4") || (str == "com5") || (str == "com6") || (str == "com7") || (str == "com8") || (str == "com9") || (str == "com10"))
	{
		m_strPortName = str;//Изменяем параметр СОМ порта
		pserialPort->setPortName(str);
	}
	/////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////Н А С Т Р О Й К А   С К О Р О С Т И/////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ( str == "1200" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud1200);
	}

	if ( str == "2400" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud2400);
	}

	if ( str == "4800" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud4800);
	}

	if ( str == "9600" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud9600);
	}

	if ( str == "19200" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud19200);
	}

	if ( str == "38400" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud38400);
	}

	if ( str == "57600")
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud57600);
	}

	if ( str == "115200" )
	{
		m_strBaudRate = str;//Изменяем параметр СОМ порта
		pserialPort->setBaudRate(QSerialPort::Baud115200);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////Н А С Т Р О Й К А   D A T A   B I T S////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ( str == "5" )
	{
		m_strDataBits = str;//Изменяем параметр СОМ порта
		pserialPort->setDataBits(QSerialPort::Data5);
	}

	if ( str == "6" )
	{
		m_strDataBits = str;//Изменяем параметр СОМ порта
		pserialPort->setDataBits(QSerialPort::Data6);
	}

	if ( str == "7" )
	{
		m_strDataBits = str;//Изменяем параметр СОМ порта
		pserialPort->setDataBits(QSerialPort::Data7);
	}

	if ( str == "8" )
	{
		m_strDataBits = str;//Изменяем параметр СОМ порта
		pserialPort->setDataBits(QSerialPort::Data8);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////Н А С Т Р О Й К А   P A R I T Y///////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ( str == "none" )
	{
		m_strParity = str;//Изменяем параметр СОМ порта
		pserialPort->setParity(QSerialPort::NoParity);
	}

	if ( str == "odd" )
	{
		m_strParity = str;//Изменяем параметр СОМ порта
		pserialPort->setParity(QSerialPort::OddParity);
	}

	if ( str == "even" )
	{
		m_strParity = str;//Изменяем параметр СОМ порта
		pserialPort->setParity(QSerialPort::EvenParity);
	}

	if ( str == "space" )
	{
		m_strParity = str;//Изменяем параметр СОМ порта
		pserialPort->setParity(QSerialPort::SpaceParity);
	}

	if ( str == "mark" )
	{
		m_strParity = str;//Изменяем параметр СОМ порта
		pserialPort->setParity(QSerialPort::MarkParity);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////Н А С Т Р О Й К А   S T O P   B I T S////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ( str == "1" )
	{
		m_strStopBits = str;//Изменяем параметр СОМ порта
		pserialPort->setStopBits(QSerialPort::OneStop);
	}

	if ( str == "1.5" )
	{
		m_strStopBits = str;//Изменяем параметр СОМ порта
		pserialPort->setStopBits(QSerialPort::OneAndHalfStop);
	}

	if ( str == "2" )
	{
		m_strStopBits = str;//Изменяем параметр СОМ порта
		pserialPort->setStopBits(QSerialPort::TwoStop);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////Н А С Т Р О Й К А   F L O W   C O N T R O L/////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////
	if ( str == "NoFlowControl" )
	{
		m_strFlowControl = str;//Изменяем параметр СОМ порта
		pserialPort->setFlowControl(QSerialPort::NoFlowControl);
	}

	if ( str == "HardwareControl" )
	{
		m_strFlowControl = str;//Изменяем параметр СОМ порта
		pserialPort->setFlowControl(QSerialPort::HardwareControl);
	}

	if ( str == "SoftwareControl" )
	{
		m_strFlowControl = str;//Изменяем параметр СОМ порта
		pserialPort->setFlowControl(QSerialPort::SoftwareControl);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////S L O T   C O N N E C T   B U T T O N   C L I C K E D////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotConnectButtonClicked()//Слот открывающий и закрывающий Сом порт
{
	QString strStatusComPort("");//Составная строчка статуса порта
	strStatusComPort = m_strPortName;//наделяем строчку именем порта
	if (m_blConnectButtonClicked)//Если флаг нажатия Включателя активен, то...
	{
		strStatusComPort += " порт закрыт.";//добавляем к имени порта его статус
		pserialPort->close();//Закрываем сом порт
		m_blConnectButtonClicked = false;//делаем флаг нажатия Включателя не активным
		ptxtReadCom->append(strStatusComPort);//Отображаем статус порта
		pgbxComPort->setEnabled(true);//Активируем сборку с выбором СОМ портов
	}
	else
	{
		setComPortName();//Настраиваем номер СОМ порта
		if (pserialPort->open(QIODevice::ReadWrite))//Открываем сом порт для чтения и записи и одновреммено проверяем его открытие
		{
			strStatusComPort += " порт открыт.";//добавляем к имени порта его статус
			ptxtReadCom->append(strStatusComPort);//Отображаем статус порта
			pgbxComPort->setEnabled(false);//Деактивируем сборку с выбором СОМ портов
		}
		else//Если порт не открылся, то...
		{
			strStatusComPort += " порт не открыт.";//добавляем к имени порта его статус
			ptxtReadCom->append(strStatusComPort);//Отображаем статус порта
			pcmdConnect->setChecked(false);//Делаем кнопку "Подкючить" в режим ВЫКЛ.
			m_blConnectButtonClicked = false;//делаем флаг нажатия Включателя не активным
			return;//Выход из функции
		}

		setComPortSetting();//Задаем настройки СОМ порта
		m_blConnectButtonClicked = true;//делаем флаг нажатия Включателя не активным
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////S L O T   R E A D   C O M   D A T A/////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotReadComData()//Слот чтения символа пришедшего с сом порта и его отображение
{
	char chrComChar;//Символ, к которому присвоится значение символа, принятого по сом порту
	while(pserialPort->getChar(&chrComChar) == true)//принимает символ по сом порту
		m_strComRead +=chrComChar;//Добовляем символ в составную строчку

	ptxtReadCom->setText(m_strComRead);//Отображаем составную строчку в окне
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////S L O T   W R I T E   C O M   D A T A////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotWriteComData()
{
	m_strComWrite += '\0';//Добавляем конец строки
	QString*  pstrComWrite = new QString(m_strComWrite);//Создаем динамический указатель, у конструкторе присваиваем ему значение строчки QString
	QByteArray btrWriteComData = pstrComWrite->toLocal8Bit();//Приводим строку с типом QString к QByteArray
	pserialPort->write(btrWriteComData);//Отправляем данные по СОМ порту
	m_strComWrite = "";//Очищаем буфер передачи данных по СОМ порту.
	ptxtWriteCom->clear();//Очищаем строчку ввода данных.
	qDebug() << "SEND:" << btrWriteComData;
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////S L O T   W R I T E   T E X T////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotWriteText(const QString& rstrWriteText)//Слот присваевает значение вводимой строчки переменной класса
{
	m_strComWrite = rstrWriteText;//Присвоение вводимой строчки переменной класса
}

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////S L O T   M A I N   Q U I T/////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotMainQuit()//Слот закрытия программы
{
	pserialPort->close();//Закрываем сом порт, если он был открыт
	qApp->quit();//закрываем приложение
}

/////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////S L O T   R E A D   C L E A R////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::slotReadClear()//Слот очистки экрана приема данных по СОМ порту
{
	m_strComRead = "";//Опустошаем буфер данных принятых по СОМ порту
	ptxtReadCom->clear();//Очистка поля ввода
}

/////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////S E T   P O R T   N A M E/////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::setComPortName()//Функция настройки СОМ ПОРТА
{
	pserialPort->setPortName(m_strPortName);//Задаем номер СОМ порта
}

/////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////S E T   C O M   P O R T   S E T T I N G///////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
void DCTerminal::setComPortSetting()//Функция Настройки СОМ порта
{
	//Настройка скорости порта
	if ( m_strBaudRate == "1200" )
		pserialPort->setBaudRate(QSerialPort::Baud1200);

	if ( m_strBaudRate == "2400" )
		pserialPort->setBaudRate(QSerialPort::Baud2400);

	if ( m_strBaudRate == "4800" )
		pserialPort->setBaudRate(QSerialPort::Baud4800);

	if ( m_strBaudRate == "9600" )
		pserialPort->setBaudRate(QSerialPort::Baud9600);

	if ( m_strBaudRate == "19200" )
		pserialPort->setBaudRate(QSerialPort::Baud19200);

	if ( m_strBaudRate == "38400" )
		pserialPort->setBaudRate(QSerialPort::Baud38400);

	if ( m_strBaudRate == "57600")
		pserialPort->setBaudRate(QSerialPort::Baud57600);

	if ( m_strBaudRate == "115200" )
		pserialPort->setBaudRate(QSerialPort::Baud115200);

	//Настройка количества бит в пакете
	if ( m_strDataBits == "5" )
		pserialPort->setDataBits(QSerialPort::Data5);

	if ( m_strDataBits == "6" )
		pserialPort->setDataBits(QSerialPort::Data6);

	if ( m_strDataBits == "7" )
		pserialPort->setDataBits(QSerialPort::Data7);

	if ( m_strDataBits == "8" )
		pserialPort->setDataBits(QSerialPort::Data8);

	//Настройка Parity
	if ( m_strParity == "none" )
		pserialPort->setParity(QSerialPort::NoParity);

	if ( m_strParity == "odd" )
		pserialPort->setParity(QSerialPort::OddParity);

	if ( m_strParity == "even" )
		pserialPort->setParity(QSerialPort::EvenParity);

	if ( m_strParity == "space" )
		pserialPort->setParity(QSerialPort::SpaceParity);

	if ( m_strParity == "mark" )
		pserialPort->setParity(QSerialPort::MarkParity);

	//Настройка стоповых бит
	if ( m_strStopBits == "1" )
		pserialPort->setStopBits(QSerialPort::OneStop);

	if ( m_strStopBits == "1.5" )
		pserialPort->setStopBits(QSerialPort::OneAndHalfStop);

	if ( m_strStopBits == "2" )
		pserialPort->setStopBits(QSerialPort::TwoStop);

	//Настройка FlowControl
	if ( m_strFlowControl == "NoFlowControl" )
		pserialPort->setFlowControl(QSerialPort::NoFlowControl);

	if ( m_strFlowControl == "HardwareControl" )
		pserialPort->setFlowControl(QSerialPort::HardwareControl);

	if ( m_strFlowControl == "SoftwareControl" )
		pserialPort->setFlowControl(QSerialPort::SoftwareControl);
}
