/*
 * DCTerminal.h
 *
 *		   IDE: Eclipse Kepler
 *  Created on: 04. Октября. 2013 г.
 *      Author: DruidCat
 */

#ifndef DCTERMINAL_H_
#define DCTERMINAL_H_

#include <QWidget>
#include <QRadioButton>
#include <QTextEdit>
#include <QSerialPort>
#include <QLineEdit>
#include <QGroupBox>
#include <QPushButton>
#include <QSerialPortInfo>
#include <QLabel>
#include <QList>

class DCTerminal: public QWidget
{
	Q_OBJECT

public:
	DCTerminal(QWidget* pwgt = 0);//Конструктор класса Терминал

private slots:
	void				slotRadioButtonClicked	(								);//Слот обрабатывающий нажатие радио кнопок
	void				slotReadComData			(								);//Слот чтения символа пришедшего с СОМ порта и его отображение
	void				slotWriteComData		(								);//Слот записи символов в СОМ порт
	void				slotWriteText			(const QString& rstrWriteText	);//Слот присваевает значение вводимой строчки переменной класса
	void				slotConnectButtonClicked(								);//Слот открывающий и закрывающий СОМ порт
	void				slotReadClear			(								);//Слот очистки экрана приема данных по СОМ порту
	void				slotMainQuit			(								);//Слот закрытия программы

private:

	QSerialPort*		pserialPort;//Указатель на класс QSerialPort

	QGroupBox*			pgbxComPort;//Группировочный виджет кнопок управления Терминалом
	QPushButton*		pcmdConnect;//Кнопка "Подключение"
	QLabel*				plblShowInfo;//Информация о программе
	QTextEdit*			ptxtReadCom;//Указатель на элемент Отображения принятого по сом порту текстра
	QLineEdit*			ptxtWriteCom;//Указатель на элемент текста, для отправки его по СОМ порту

	QRadioButton*		createRadioButton		(const QString& rstrNameButton	);//Метод принимающий название радио кнопки в виде ссылки и возвращающий указатель на созданную радио кнопку

	void				setComPortName			(								);//Функция настройки СОМ ПОРТА
	void				setComPortSetting		(								);//Функция Настройки СОМ порта

	unsigned int		m_uiComSettingCounter;//Счетчик активизированных настроет по умолчанию.

	QString				m_strComRead;//Строка, в которую будут добавляться символы, принятые по СОМ порту.
	QString				m_strComWrite;//Строка, которая отправится по СОМ порту
	QString				m_strPortName;//Настройка порта
	QString				m_strBaudRate;//Настройка скорости порта
	QString				m_strDataBits;//Настройка количества бит в пакете
	QString				m_strParity;//Настройка Parity
	QString				m_strStopBits;//Настройка стоповых бит
	QString				m_strFlowControl;//Настройка Flow Control

	bool				m_blConnectButtonClicked;//Флаг нажатия кнопки Соединение
};

#endif /* DCTERMINAL_H_ */
